> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Swap workbook data sources

POST https://api.sigmacomputing.com/v2/workbooks/{workbookId}/swapSources
Content-Type: application/json

Swap the data sources used by a workbook. You can swap from one connection to another, and/or from one dataset or table to another.

  ### Usage notes
  - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.
  - Retrieve the **connectionId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
  - Retrieve the sources used by a workbook from the [v2/workbooks/{workbookId}/sources](https://help.sigmacomputing.com/reference/get-workbook-sources) endpoint.

  - To swap all tables in a connection, set the `swapTables` option to `true`.

    - Use the `paths` option to specify the connection paths to swap. The connection path is a list of strings that represents the path to the table in the cloud data warehouse. For example, `["database", "schema", "table"]`.
    - If the table schema is the same in both connections, leave the `paths` option empty to swap all tables in the connection. You can also pass a partial path to swap between databases, catalogs, or schemas.
    - If `sourceMapping` is provided, those mappings take precedence over the connection swaps.
    - If `swapTables` is not set to `true`, only Custom SQL elements have their connections changed.

  ### Usage scenarios
  - **Workbook development**: Use a test data source while developing a workbook, then swap the source to a production database when ready to share the workbook for production use.
    

Reference: https://help.sigmacomputing.com/reference/source-swap-workbook

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/workbooks/{workbookId}/swapSources:
    post:
      operationId: sourceSwapWorkbook
      summary: Swap workbook data sources
      description: >-
        Swap the data sources used by a workbook. You can swap from one
        connection to another, and/or from one dataset or table to another.

          ### Usage notes
          - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.
          - Retrieve the **connectionId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
          - Retrieve the sources used by a workbook from the [v2/workbooks/{workbookId}/sources](https://help.sigmacomputing.com/reference/get-workbook-sources) endpoint.

          - To swap all tables in a connection, set the `swapTables` option to `true`.

            - Use the `paths` option to specify the connection paths to swap. The connection path is a list of strings that represents the path to the table in the cloud data warehouse. For example, `["database", "schema", "table"]`.
            - If the table schema is the same in both connections, leave the `paths` option empty to swap all tables in the connection. You can also pass a partial path to swap between databases, catalogs, or schemas.
            - If `sourceMapping` is provided, those mappings take precedence over the connection swaps.
            - If `swapTables` is not set to `true`, only Custom SQL elements have their connections changed.

          ### Usage scenarios
          - **Workbook development**: Use a test data source while developing a workbook, then swap the source to a production database when ready to share the workbook for production use.
            
      tags:
        - Workbooks
      parameters:
        - name: workbookId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/workbooks_sourceSwapWorkbook_Response_200'
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                sourceMapping:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItems
                connectionMapping:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems
                copyInputTableData:
                  type: boolean
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems:
      type: object
      properties:
        fromMetric:
          type: string
          description: Metric in the data source.
        toMetric:
          type: string
          description: Metric in the data source.
      required:
        - fromMetric
        - toMetric
      title: >-
        V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems
    V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn:
      oneOf:
        - type: string
        - type: array
          items:
            type: string
      title: >-
        V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn
    V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn:
      oneOf:
        - type: string
        - type: array
          items:
            type: string
      title: >-
        V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn
    V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems:
      type: object
      properties:
        fromColumn:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn
        toColumn:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn
      required:
        - fromColumn
        - toColumn
      title: >-
        V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems
    V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItems:
      type: object
      properties:
        fromId:
          type: string
          description: ID of the dataset (deprecated) or table to swap from.
        toId:
          type: string
          description: ID of the dataset (deprecated) or table to swap to.
        metricMapping:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems
        columnMapping:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems
      required:
        - fromId
        - toId
      title: >-
        V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItems
    V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems:
      type: object
      properties:
        fromPath:
          type: array
          items:
            type: string
          description: Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']
        toPath:
          type: array
          items:
            type: string
          description: Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']
      required:
        - fromPath
        - toPath
      title: >-
        V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems
    V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems:
      type: object
      properties:
        fromId:
          type: string
          description: ID of the connection to swap from.
        toId:
          type: string
          description: ID of the connection to swap to.
        swapTables:
          type: boolean
          description: Whether to swap all tables in the connection
        paths:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems
      required:
        - fromId
        - toId
      title: >-
        V2WorkbooksWorkbookIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems
    workbooks_sourceSwapWorkbook_Response_200:
      type: object
      properties:
        unswappedSources:
          type: array
          items:
            type: string
          description: IDs of sources in the workbook that were not swapped.
        unswappedConnections:
          type: array
          items:
            type: string
          description: IDs of custom SQL connections in the workbook that were not swapped.
      required:
        - unswappedSources
        - unswappedConnections
      title: workbooks_sourceSwapWorkbook_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "unswappedSources": [
    "dataset-12345"
  ],
  "unswappedConnections": [
    "conn-67890"
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/swapSources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```